// You can import API functions like this from D3.js.
import { select, csv } from 'd3';

const getArtisteURL =
  'https://wasabi.i3s.unice.fr/api/v1/artist_all/name/';

var artistesAssocies = [];
var artiste;
var dataForConnection = [];

var margin = {
    top: 10,
    right: 30,
    bottom: 30,
    left: 40,
  },
  width = 400 - margin.left - margin.right,
  height = 400 - margin.top - margin.bottom;

// append the svg object to the body of the page
var svg = d3
  .select('#my_dataviz')
  .append('svg')
  .attr(
    'width',
    width + margin.left + margin.right
  )
  .attr(
    'height',
    height + margin.top + margin.bottom
  )
  .append('g')
  .attr(
    'transform',
    'translate(' +
      margin.left +
      ',' +
      margin.top +
      ')'
  );

// Defining async function
async function getapi(url) {
  // Storing response
  const response = await fetch(url);

  // Storing data in form of JSON
  var data = await response.json();
  //console.log(data);
  return data;
}

async function grosseFonction(nom) {
  artiste = await getapi(getArtisteURL + nom);
  //console.log(artiste);
  var listeLabels = [];
  //console.log(artiste);
  //console.log(artiste.albums);
  //var artisteName = artiste.name;
  artiste.albums.forEach((album) => {
    album.songs.forEach((song) => {
      //console.log(song.writer);
     if (song.recordLabel != null) {
        song.recordLabel.forEach((recordLabel) => {
          console.log(recordLabel);
          if (
            !listeLabels.includes(recordLabel) &&
            recordLabel.name != recordLabel
          ) {
            listeLabels.push(recordLabel);
          }
        });
      }
    });
  });
  //Liste de l'ensemble des labels d'un artiste
  console.log(listeLabels);
 	artiste.associatedMusicalArtist.forEach((a)=>{
      artistesAssocies.push(a);    
    });

   for (let i = 0; i < artistesAssocies.length; i++) {
      artistesAssocies.push({
        _id :artistesAssocies[i]._id,
        index: i - 1,
        _id: artistesAssocies[i]._id,
        name: artistesAssocies[i].name,
      });
   }
    console.log(artistesAssocies);
  
  //Recherche des artistes associés correspondant à l'artiste
  //artistesAssocies
  
  console.log(artistesAssocies);
  render(await transfo());
}

var render = async function (data) {
  console.log(data);
  var link = svg
    .selectAll('line')
    .data(data.links)
    .enter()
    .append('line')
    .style('stroke', '#aaa');

  // Initialize the nodes
  var node = svg
    .selectAll('circle')
    .data(data.nodes)
    .enter()
    .append('circle')
    .attr('r', 20)
    .style('fill', '#69b3a2')
    .on('mouseover', mouseover)
    .on('mouseleave', mouseleave)
    .on('mousemove', mousemove);

  // Let's list the force we wanna apply on the network
  var simulation = d3
    .forceSimulation(data.nodes) // Force algorithm is applied to data.nodes
    .force(
      'link',
      d3
        .forceLink() // This force provides links between nodes
        .id(function (d) {
          return d.id;
        }) // This provide  the id of a node
        .links(data.links) // and this the list of links
    )
    .force(
      'charge',
      d3.forceManyBody().strength(-1000)
    ) // This adds repulsion between nodes. Play with the -400 for the repulsion strength
    .force(
      'center',
      d3.forceCenter(width / 2, height / 2)
    ) // This force attracts nodes to the center of the svg area
    .on('end', ticked);

  // This function is run at each iteration of the force algorithm, updating the nodes position.
  function ticked() {
    link
      .attr('x1', function (d) {
        return d.source.x;
      })
      .attr('y1', function (d) {
        return d.source.y;
      })
      .attr('x2', function (d) {
        return d.target.x;
      })
      .attr('y2', function (d) {
        return d.target.y;
      });

    node
      .attr('cx', function (d) {
        return d.x + 6;
      })
      .attr('cy', function (d) {
        return d.y - 6;
      });
  }
};

var transfo = async function () {
  console.log(artiste);
  var links = [];
  var nodes = [];
  let i = 1;
  nodes.push({
    id: i,
    index: i - 1,
    name: artiste.name,
    _id: artiste._id,
    recordLabel: artiste.recordLabel,
  });
  //i += 1;

  console.log(artistesAssocies);
  for (let j=0 ; j < artistesAssocies.length; j++) {
    //if (featArtiste[j].name != artiste.name) {
    nodes.push({
      id: i,
      index: i - 1,
      name: artistesAssocies[j].name,
      _id: artistesAssocies[j]._id,
      recordLabel: artistesAssocies[j].recordLabel,
    });
    //console.log("$$$$$$$$$$");
    console.log(nodes);
    links.push({
      index: j,
      source: nodes[0],
      target: nodes[i - 1],
    });
    console.log(nodes[i - 1]);
    i += 1;
  }

  dataForConnection = {
    nodes: nodes,
    links: links,
  };
  console.log(dataForConnection);
  return dataForConnection;
};

var mouseover = function (d) {
  if (d.recordLabel == null) {
    d.recordLabel = 0;
  }

  d3.select('div.tooltip')
    .html(
      'Name: ' +
        d.name +
        '<br>' +
        'Label: ' +
        d.recordLabel
    )
    .style('opacity', 1)
    .style('left', d3.event.pageX + 10 + 'px')
    .style('top', d3.event.pageY + 10 + 'px');
};

var mousemove = function (d) {
  d3.select('div.tooltip')
    .style('opacity', 1)
    .style('left', d3.event.pageX + 10 + 'px')
    .style('top', d3.event.pageY + 10 + 'px');
};
var mouseleave = function (d) {
  d3.select('div.tooltip')
    .html('')
    .style('opacity', 0);
};

//Récupération des données d'un chanteur :
grosseFonction('Metalli